#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		nodove		dovenull
%define		majver		%(echo %{version} | cut -d '.' -f1-2)
%define		phn		pigeonhole
%define		phv		0.5.21
#-----------------------------------------------------------------------------
Name		:	dovecot
Version		:	2.3.21
Release		:	17.0.10.rel%{?dist}
Summary		:	Dovecot, an IMAP and POP server
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://www.dovecot.org/releases
			#https://pigeonhole.dovecot.org/download.html

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
Source2		:	%{name}-%{majver}-pigeonhole-%{phv}.tar.gz
patch0		:	%{name}-%{version}-openssl3_fixes-1.patch
patch1		:	%{name}-%{version}-security_fix-1.patch

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	automake
BuildRequires	:	krb5-devel
BuildRequires	:	libcap-devel
BuildRequires	:	libtirpc
BuildRequires	:	libtool
BuildRequires	:	mariadb
BuildRequires	:	openldap-devel
BuildRequires	:	postgresql
BuildRequires	:	sqlite
BuildRequires	:	lua

Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	shadow
Requires	:	libtirpc
Requires	:	logrotate
Requires	:	openssl
#-----------------------------------------------------------------------------
%description
Dovecot is an open source IMAP and POP3 email server for Linux/UNIX-like
systems, written with security primarily in mind. Dovecot is an excellent
choice for both small and large installations. It's fast, simple to set up,
requires no special administration and it uses very little memory.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS README
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/%{name}
%config (noreplace) %{_sysconfdir}/logrotate.d/%{name}

%dir %attr (0750,mail,mail) %{_var}/spool/mails
%attr (0640,mail,mail) %{_var}/spool/mails/root

%config (noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-auth.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-director.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-logging.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-mail.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-master.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-ssl.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/15-lda.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/15-mailboxes.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/20-imap.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/20-lmtp.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/20-pop3.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/20-submission.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/90-acl.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/90-quota.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/90-plugin.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-checkpassword.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-deny.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-dict.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-ldap.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-master.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-passwdfile.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-sql.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-static.conf.ext
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/auth-system.conf.ext

%{_sysconfdir}/%{name}/README
%{_bindir}/doveadm
%{_bindir}/doveconf
%{_bindir}/dsync
%{_bindir}/%{name}-sysreport
%{_sbindir}/%{name}
%{_libexecdir}/%{name}/*
%{_libdir}/%{name}/auth/lib20_auth_var_expand_crypt.so
%{_libdir}/%{name}/auth/libauthdb_imap.so
%{_libdir}/%{name}/auth/libauthdb_ldap.so
%{_libdir}/%{name}/auth/libdriver_sqlite.so
%{_libdir}/%{name}/auth/libmech_gssapi.so
%{_libdir}/%{name}/doveadm/*
%{_libdir}/%{name}/old-stats/*
%{_libdir}/%{name}/lib20_var_expand_crypt.so
%{_libdir}/%{name}/dict/libdriver_sqlite.so
%{_libdir}/%{name}/libdriver_sqlite.so
#these (*.so files) are plugins, not devel files
%{_libdir}/dovecot/*_plugin.so
%{_libdir}/%{name}/libdcrypt_openssl.so
%{_libdir}/%{name}/libfs_compress.so
%{_libdir}/%{name}/libfs_crypt.so
%{_libdir}/%{name}/libfs_mail_crypt.so
%{_libdir}/%{name}/libssl_iostream_openssl.so
%{_libdir}/%{name}/dict/libdict_ldap.so
%{_libdir}/%{name}/lib%{name}.so.*
%{_libdir}/%{name}/lib%{name}-*.so.*
%{_defaultdocdir}/%{name}-%{version}/%{name}-openssl.cnf
%{_defaultdocdir}/%{name}-%{version}/mkcert.sh
%{_defaultdocdir}/%{name}-%{version}/solr-schema.xml
%{_defaultdocdir}/%{name}-%{version}/solr-schema-7.7.0.xml
%{_defaultdocdir}/%{name}-%{version}/solr-config-7.7.0.xml
%{_defaultdocdir}/%{name}-%{version}/example-config/*
%{_defaultdocdir}/%{name}-%{version}/*.txt
%{_defaultdocdir}/%{name}-%{version}/wiki/*.txt
%{_datadir}/%{name}/stopwords/*.txt
%{_mandir}/man1/*.1.gz
%{_mandir}/man7/*.7.gz

#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}
  /usr/sbin/userdel %{name}
  /usr/sbin/userdel %{nodove}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{name}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

    /usr/sbin/useradd 				\
	-r 					\
	-c "Dovecot IMAP server"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{_libexecdir}/%{name}		\
	%{name}

    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{nodove}

    /usr/sbin/useradd 				\
	-r 					\
	-c "Dovecot's unauthorized user"	\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{nodove}				\
	-d /dev/null				\
	-s /bin/false				\
	 %{nodove}
    fi
  fi


%post
if [ "$1" = 1 ]; then
  %{_sbindir}/chkconfig --add %{name}
  fi
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		%{phn}
Summary		:	Sieve and managesieve plug-in for dovecot

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		%{phn}
This package provides sieve and managesieve plug-in for dovecot LDA.

#-----------------------------------------------------------------------------
%files			%{phn}
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/10-metrics.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/20-managesieve.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/90-sieve.conf
%config(noreplace) %{_sysconfdir}/%{name}/conf.d/90-sieve-extprograms.conf
%{_bindir}/sieve-dump
%{_bindir}/sieve-filter
%{_bindir}/sieve-test
%{_bindir}/sievec
%{_libdir}/%{name}/settings/libmanagesieve_*.so
%{_libdir}/%{name}/settings/libpigeonhole_*.so
%{_libdir}/%{name}/sieve/lib*_plugin.so
%{_defaultdocdir}/%{name}-%{version}/sieve/extensions/*.txt
%{_defaultdocdir}/%{name}-%{version}/sieve/locations/*.txt
%{_defaultdocdir}/%{name}-%{version}/sieve/plugins/*.txt


#=============================================================================
%package		devel
Summary		:	Development files for '%{name}'

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package provides the development files for '%{name}'.

#-----------------------------------------------------------------------------
%files			devel
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/sieve/*.h
%{_datadir}/aclocal/%{name}*.m4
%{_libdir}/%{name}/lib%{name}*.so
%{_libdir}/%{name}/%{name}-config

#=============================================================================
%package		postgresql
Summary		:	Postgres SQL back end for dovecot

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
Requires	:	postgresql

#-----------------------------------------------------------------------------
%description		postgresql
This package provides the Postgres SQL back end for dovecot-auth etc.

#-----------------------------------------------------------------------------
%files			postgresql
%{_libdir}/%{name}/libdriver_pgsql.so
%{_libdir}/%{name}/auth/libdriver_pgsql.so
%{_libdir}/%{name}/dict/libdriver_pgsql.so

#=============================================================================
%package		mysql
Summary		:	mysql SQL back end for dovecot

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
Requires	:	mysql

#-----------------------------------------------------------------------------
%description		mysql
This package provides the mysql (or mariadb) SQL back end for dovecot-auth etc.

#-----------------------------------------------------------------------------
%files			mysql
%{_libdir}/%{name}/libdriver_mysql.so
%{_libdir}/%{name}/auth/libdriver_mysql.so
%{_libdir}/%{name}/dict/libdriver_mysql.so

#=============================================================================
%prep
%setup -q -n %{name}-%{version}
%patch -P 0 -p1
%patch -P 1 -p1

tar xf %{SOURCE1}
tar xf %{SOURCE2}

#-----------------------------------------------------------------------------
#building application
%build

#sed -i							\
#  -e "/clude <unistd.h>/a#include <crypt.h>"		\
#  src/auth/mycrypt.c


autoreconf -vif
CFLAGS+="-I/usr/include/tirpc"				\
LDFLAGS+="-ltirpc"					\
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--localstatedir=%{_var}				\
	--disable-static				\
	--disable-rpath					\
	--with-nss					\
	--with-shadow					\
	--with-pam=no					\
	--with-gssapi=plugin				\
	--with-ldap=plugin				\
	--with-sql=plugin				\
	--with-pgsql					\
	--with-mysql					\
	--with-sqlite					\
	--with-zlib					\
	--with-libcap					\
	--with-lua					\
	--with-docs					\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#doing pigeonhole
pushd %{name}-%{majver}-%{phn}-%{phv}
autoreconf -vif
./configure						\
	INSTALL_DATA="install -c -p -m644"		\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{phn}-%{phv}\
	--localstatedir=%{_var}				\
	--disable-static				\
	--with-ldap=yes					\
	--with-dovecot=../				\
	--with-docs					\
	--with-managesieve				\
	--without-unfinished-features			\

%{__make} %{_smp_mflags}
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}/conf.d

pushd %{name}-%{majver}-%{phn}-%{phv}
%{__make}						\
	DESTDIR=%{buildroot}				\
	install

install -p -m 644					\
	 doc/example-config/conf.d/*.conf		\
	%{buildroot}%{_sysconfdir}/%{name}/conf.d
popd

 
# Install dovecot configuration
install -p -m 644					\
	doc/example-config/conf.d/*.conf		\
	%{buildroot}%{_sysconfdir}/%{name}/conf.d
install -p -m 644					\
	doc/example-config/conf.d/*.conf.ext		\
	%{buildroot}%{_sysconfdir}/%{name}/conf.d

#installing dovecot mails repository
%{__mkdir_p} %{buildroot}%{_var}/spool/mails/root

#installing dovecot logrotate directive
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}.logrotate		\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#installing dovecot starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#installing dovecot configuration file
%{__cp} -a 						\
	%{name}-ok_addon/%{name}.conf			\
	%{buildroot}%{_sysconfdir}/%{name}

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
